var GlobalSpace = {
	json_debug: 0,
	dataurl:"/goform/mainBoard",
	page_id:3,
	ip_num:2,
	ip_p_num: 80,
	asi_p_num: 4,
	mux_num:4,
	//DEF_TSOIP_NET:19,
	//DEF_TSOIP_MODE:20,
	DefaultFormId:34,
	web_version:3022,
	BOARD_INFO:{},
	INIT:{},
	VERSION:{},
	in_s_cobj:{ 
		BOARD_INFO: {form_id: 6}
	},	
	mybusy_data:loadvalue(),
	def_ajax_para:{
		bk_fn:ajaxBk_before,
		bkrm_fn:ajaxBk_end
	}
};

var DEF={
	AJAX_BK:{
		DEFAULT:0,
		LOAD:1,
		NO:2,

		REMOVE2:255
	},
	SEND_TYPE:{
		GIVE:0,
		GET:1
	}
};

var barInfo = {
	basicInfos:{
		siteID:"rebootID",
		rTime:1000,
		modeStyle:"rectangle",
		isAjaxGetTime:false,
		isModal:false
	},
	styleInfos:{
		rGeoPostion:"relative",
		rGeoLocation:["0px","0px","0px","0px"],
		rWidth:"340px",
		rHeight:"30px",

		rBorderRadius:"10px",
		//span
		procColor:"red",
		procFontSize:"13px",
		procBgColor:"#03B40A"
	},
	timeData:{
		bgToalTime:0
	}
};
function pad(num, n){
	return n>num.length?(Array(n).join('0') + num).slice(-n):num;
}
function ajaxBk_before(bk_type){
	var G = GlobalSpace;

	switch(bk_type){
		case DEF.AJAX_BK.DEFAULT:
			G.mybusy_data.settext();
			break;
		case DEF.AJAX_BK.LOAD:
			G.mybusy_data.loadsth();
			break;
		case DEF.AJAX_BK.NO:
			break;
		default:
			G.mybusy_data.settext();
			break;
	}
}
function ajaxBk_end(bk_type){
	var G = GlobalSpace;

	switch(bk_type){
		case DEF.AJAX_BK.REMOVE2:
			G.mybusy_data.remove2();
			break;
		default:
			G.mybusy_data.remove();
			break;
	}
}
function apply_callback(type,data){
	console.log(type);
	switch(type){

		case 36:
			if($('#sel',parent.document.body).val()==1)
				alert("Reboot modules successfully!");
			else
				alert("重启子板成功!");
			break;
		default:
			break;
	}
}

function ajax_func_handler(data, fn, ajax_para){
	switch(ajax_para.type){
		case DEF.SEND_TYPE.GIVE:
			fn(ajax_para.form_id,data);
			break;
	}
}

function ajaxWrap(jsonStr, fn, ajax_para){
	$.ajax({
		dataType: "json",
		type: 'POST',
		url:GlobalSpace.dataurl+'?id='+GlobalSpace.page_id,
		data:{json:jsonStr},
		beforeSend:function(XMLHttpRequest){
			mybusy = loadvalue();
			mybusy.settext();
		},
		success: function(data){
			mybusy.remove();
			ajax_func_handler(data, fn, ajax_para);
		},
		error: function(data){
			mybusy.remove();
		}
	});
}

function ajaxWraptrap(jsonStr,ajax_para){
	$.ajax({
		dataType: "json",
		type: 'POST',
		url:GlobalSpace.dataurl+'?id='+23,
		data:{json:jsonStr},
		beforeSend:function(XMLHttpRequest){
			mybusy = loadvalue();
			mybusy.settext();
		},
		success: function(data){
			mybusy.remove();
		},
		error: function(data){
			mybusy.remove();
		}
	});
}


function applyResetSonBoard() {
	var	ajax_para={},
		jsonStr = "",
		json_obj=
		{
			RESETSON:
			{
				form_id: 36,
				value:[]
			}

		};

	if($("#selRetSon").multiselect("MyValues") == ""){
		if ($('#sel', parent.document.body).val() == 1)
			alert("Please select at least one!");
		else
			alert("请至少选择一个！");
	}else {
		let selValue = $("#selRetSon").multiselect("MyValues").split(",.")[0].split(",");
		for (var i = 0; i < selValue.length; i++) {
			json_obj.RESETSON.value.push(parseInt(selValue[i]));
		}

		jsonStr = $.toJSON(json_obj);
		console.log(jsonStr);

		ajax_para.form_id = json_obj.RESETSON.form_id;
		ajax_para.type = DEF.SEND_TYPE.GIVE;
		ajaxWrap(jsonStr, apply_callback, ajax_para);
	}
}

function SerToSonBoard() {
	var	ajax_para={},
		jsonStr = "",
		json_obj=
			{
				serToSon:
					{
						form_id: 101,
						value:{}
					}

			};

	json_obj.serToSon.value.moduleIdx = parseInt($("#selSerialToSon").val());
	jsonStr = $.toJSON(json_obj);
	console.log(jsonStr);

	ajax_para.form_id = json_obj.serToSon.form_id;
	ajax_para.type = DEF.SEND_TYPE.GIVE;
	ajaxWrap(jsonStr, apply_callback, ajax_para);
}

function setup_buzzer(){
	var json_obj = {SET_BUZZER:{form_id:100,value:{} }},
		jsonStr = "",
		ajax_para={};

	json_obj.SET_BUZZER.value.buzzerSw = parseInt($('#buzzerSw').val());

	jsonStr= $.toJSON(json_obj);
	console.log(jsonStr);
	ajax_para.type = DEF.SEND_TYPE.GIVE;
	ajax_para.form_id = 100;

	ajaxWrap(jsonStr, apply_callback, ajax_para);
}

/*flag=1 reboot; flag=2 default */
function setup_reboot(flag){
	if(flag == 1) {
		barInfo.basicInfos.siteID = "rebootID" ;
		if(barInfo.basicInfos.siteID && document.getElementById(barInfo.basicInfos.siteID)&&(document.getElementById(barInfo.basicInfos.siteID).children.length<1))
		{
			if($('#sel',parent.document.body).val()==1)
			var r = confirm("Do you want to restart the device?");
			else
				var r = confirm("确定想要重启设备吗?");
			if(r == false)
			{
				return false;
			}
		}else  if(barInfo.basicInfos.siteID && document.getElementById(barInfo.basicInfos.siteID)&&(document.getElementById(barInfo.basicInfos.siteID).children.length >=1))
		{
			//console.log(document.getElementById(barInfo.basicInfos.siteID).children[0].children[0].style.width );
			if(document.getElementById(barInfo.basicInfos.siteID).children[0].children[0].style.width == "100%" ) {
				if($('#sel',parent.document.body).val()==1)
				    alert("Please refresh the page at first  !!! ");
				else
					alert("请先刷新页面 !!! ");
			}else {
				if($('#sel',parent.document.body).val()==1)
				alert("The device is restarting, please wait a moment  !!! ");
				else
					alert("设备正在重启，请稍等 !!! ");
			}
			return ;
		}
		else
			return ;
	}
	var G=Global;
	G.def_ajax_para.url	= '/goform/reboot';

	$.ajax({
		dataType: "json",
		type: 'POST',
		url:G.def_ajax_para.url,
		data:{json:''},
		success: function(data){
			if(parseInt(flag) == 2)
			{
				barInfo.basicInfos.siteID = "defaultBar" ;
				if($('#sel',parent.document.body).val()==1)
				$("#common_confirm_model .modal-header .title").html("Device is restarting. Please wait a moment...");
				else
					$("#common_confirm_model .modal-header .title").html("设备正在重启， 请稍等...");

				$("#common_confirm_model .modal-footer .ok").attr("disabled",true);
				$("#defaultBar").show();
				$("#prompts").hide();
			}
			//console.log(GlobalSpace.INIT.value.max_uptime);
			barInfo.timeData.bgToalTime = (parseInt(GlobalSpace.INIT.value.max_uptime)>0 && GlobalSpace.INIT.value.max_uptime!=undefined)?GlobalSpace.INIT.value.max_uptime:0;
			//barInfo.timeData.bgToalTime = 12000;
			//console.log(barInfo.timeData.bgToalTime);
			if(barInfo.basicInfos.siteID && document.getElementById(barInfo.basicInfos.siteID)&&(document.getElementById(barInfo.basicInfos.siteID).children.length<1))
				ProcessBar.creat(barInfo);
		},
		error: function(data){
			var errormsg='';
			if(flag ==1)
			{
				errormsg = "Reboot";
			}else if(flag == 2)
			{
				errormsg = "Default";
			}
			console.log(errormsg+" process bar error !");
		}
	});
}
function applyTypePara(apply_type_form_id)
{
	var	jsonStr = "",
		json_obj=
		{
			DATA:
			{
				form_id: parseInt(apply_type_form_id)
			}

		};
	jsonStr = $.toJSON(json_obj);
	$.ajax({
		dataType: "json",
		type: 'POST',
		url:GlobalSpace.dataurl+'?id='+GlobalSpace.page_id,
		data:{json:jsonStr},
		success: function(data){
			setup_reboot(2);
		},
		error: function(data){ console.log("Oh Oh Error!");}
	});
}

function setup_trap(){
	var	ajax_para={},
		jsonStr = "",
		json_obj=
		{
			SET_TRAP:
			{
				form_id: 42,
				value:[{
					ip:[1,2,3,4],
					trap_port:22,
	                conmunity:1,
					trap_version:0,
					trap_enable:0}
                     ]

			}

		};
	json_obj.SET_TRAP.value[0].ip[0] = parseInt( $("#ip0").val());
    json_obj.SET_TRAP.value[0].ip[1] = parseInt($("#ip1").val());
	json_obj.SET_TRAP.value[0].ip[2] = parseInt($("#ip2").val());
	json_obj.SET_TRAP.value[0].ip[3] = parseInt($("#ip3").val());
	json_obj.SET_TRAP.value[0].trap_port = parseInt($("#trap_port").val());
	json_obj.SET_TRAP.value[0].conmunity = parseInt($("#trap_conmunity").val());
	json_obj.SET_TRAP.value[0].trap_version = parseInt($("#trap_version").val());
	json_obj.SET_TRAP.value[0].trap_enable = parseInt($("#trap_enable").val());

	jsonStr = $.toJSON(json_obj);
	console.log(jsonStr);

	ajax_para.form_id = json_obj.SET_TRAP.form_id;
	ajax_para.type = DEF.SEND_TYPE.GIVE;
	ajaxWraptrap(jsonStr,ajax_para);

}



function onInitReceived(para){
	var G=GlobalSpace,
		P=para,
		obj_temp = null;
		num_temp = 0,
		str_temp = "",
		tr="";
		i = 0,
		j = 0,
		value=[];
	if(para.SET_TRAP)
		trapipTbodyGen(para);
	$('#trap_enable').on({

		change: function () {

			if ($(this).val() == 0) {
				$('.ip').attr("disabled", true);
				$('#trap_port').attr("disabled", true);
				$('#trap_conmunity').attr("disabled", true);
				$('#trap_version').attr("disabled", true);
			}else{
				$('.ip').attr("disabled", false);
				$('#trap_port').attr("disabled", false);
				$('#trap_conmunity').attr("disabled", false);
				$('#trap_version').attr("disabled", false);
			}
		}
	});
	GlobalSpace.INIT = para.INIT;
	VERSION_value = para.VERSION.value;
	let SYS_MISC = para.SYS_MISC;
	$('#ser_num').html(GlobalSpace.INIT.value.SN);
	$('#mainver').html(pad(VERSION_value.main_ver.toString(16), 4));
	$('#kernel_ver').html(pad(VERSION_value.kernel_ver.toString(16), 4));
	$('#fpgaver').html(pad(VERSION_value.FGPA_ver.toString(16), 4));
	$('#web_version').html(GlobalSpace.web_version);
	$('#app_version').html(pad(VERSION_value.APP_ver.toString(16), 4));
	$('#firm_version').html(pad(VERSION_value.firm_ver.toString(16), 4));

	$('#selSerialToSon').val(SYS_MISC.uart_switch);
	$('#buzzerSw').val(SYS_MISC.buzzer_switch);
}

var SET_TRAP_length;
function trapipTbodyGen(para){
//var language = window.top.document.getElementById("sel").value;
	if($('#sel',parent.document.body).val()==1) {
		var Trap_conmunity_attr = [
			"public",
			"private"
		];
		var Trap_version_attr = [
			"snmpv1-trap",
			//"snmpv2-trap"

		];
		var Trap_enable_attr = [
			"Disable",
			"Enable"
		];
	}else{
		var Trap_conmunity_attr = [
			"只读",
			"读/写"
		];
		var Trap_version_attr = [
			"snmpv1-trap",
			//"snmpv2-trap"

		];
		var Trap_enable_attr = [
			"关",
			"开"
		];

	}
	var tr_temp = '';
	var LocalValue = para.SET_TRAP.value;
//	console.log("LocalValue.conmunity="+LocalValue[0].conmunity);

	for(var i=0; i<LocalValue.length; i++){
		tr_temp += '<tr id="iplocal'+i+'">';
		tr_temp += '<td class="data_t">Trap#'+(i+1)+'</td>';
        if(LocalValue[i].trap_enable == 1) {
			tr_temp += "<td><input class='ip' id='ip0' type='text' size='3' maxlength='3' value='" + LocalValue[i].ipaddr[0] + "'>.";
			tr_temp += "<input class='ip' id='ip1' type='text' size='3' maxlength='3' value='" + LocalValue[i].ipaddr[1] + "'>.";
			tr_temp += "<input class='ip' id='ip2' type='text' size='3' maxlength='3' value='" + LocalValue[i].ipaddr[2] + "'>.";
			tr_temp += "<input class='ip' id='ip3' type='text' size='3' maxlength='3' value='" + LocalValue[i].ipaddr[3] + "'></td>";
		}else{
			tr_temp += "<td><input class='ip' id='ip0' type='text' size='3' maxlength='3' value='"+LocalValue[i].ipaddr[0]+" 'disabled>.";
			tr_temp += "<input class='ip' id='ip1' type='text' size='3' maxlength='3' value=' "+ LocalValue[i].ipaddr[1] + "'disabled>.";
			tr_temp += "<input class='ip' id='ip2' type='text' size='3' maxlength='3' value='" + LocalValue[i].ipaddr[2] + "'disabled>.";
			tr_temp += "<input class='ip' id='ip3' type='text' size='3' maxlength='3' value='" + LocalValue[i].ipaddr[3] + "'disabled></td>";
		}
		if(LocalValue[i].trap_enable == 1)
			tr_temp += "<td><input id='trap_port' type='text' size='10' maxlength='10' value='"+LocalValue[i].trap_port+"'></td>";
        else
			tr_temp += "<td><input id='trap_port' type='text' size='10' maxlength='10' value='"+LocalValue[i].trap_port+"'disabled></td>";

			/*var	set_td = '';
		if(LocalValue[i].trap_enable == 1)
			set_td = '<select id="trap_conmunity">';
		else
			set_td = '<select id="trap_conmunity" disabled>';
			for(var j=0; j<Trap_conmunity_attr.length; j++){
				set_td += '<option '+((LocalValue[i].conmunity==j)?'selected="selected"':'')+' value="'+j+'">'+Trap_conmunity_attr[j]+'</option>';
			}
		set_td += '</select>';
		tr_temp += '<td>'+set_td+'</td>';*/

			var	set_td = '';
		if(LocalValue[i].trap_enable == 1)
			set_td = '<select id="trap_version">';
		else
			set_td = '<select id="trap_version" disabled>';
			for(var j=0; j<Trap_version_attr.length; j++){
			//	set_td += '<option '+((LocalValue[i].trap_version==j)?'selected="selected"':'')+' value="'+j+'">'+Trap_version_attr[j]+'</option>';
				set_td += '<option  value="0">'+Trap_version_attr[0]+'</option>';
			}
		set_td += '</select>';
		tr_temp += '<td>'+set_td+'</td>';

		var	set_td = '';

		set_td = '<select id="trap_enable">';

		for(var j=0; j<Trap_enable_attr.length; j++){
			set_td += '<option '+((LocalValue[i].trap_enable==j)?'selected="selected"':'')+' value="'+j+'">'+Trap_enable_attr[j]+'</option>';
		}
		set_td += '</select>';
		tr_temp += '<td>'+set_td+'</td>';

		if($('#sel',parent.document.body).val()==1)
		tr_temp += '<td><input type="button" class="apply" onclick="setup_trap()" value="apply"></td>';
		else
		tr_temp += '<td><input type="button" class="apply" onclick="setup_trap()" value="提交"></td>';
	}
	$('#trap_ip tbody').html(tr_temp);

}
function init_system(){
	var G=GlobalSpace;
	if (G.json_debug == 1)
		G.dataurl = "system.json";
	G.def_ajax_para.url=G.dataurl+'?id='+G.page_id +"&time="+ new Date().getTime();
	$.pbi_ajaxWrap('', G.def_ajax_para, onInitReceived);
}

$(function(){
	var language = window.top.document.getElementById("sel").value;
	if(language == 1) {
		$("#verion_frame").ligerPanel({
			title: 'Version',
			width: 450,
			height: 160
		});
		$("#reset_frame").ligerPanel({
			title: 'Reboot Module',
			width: 450,
			height: 160
		});
		$("#reboot_frame").ligerPanel({
			title: 'Reboot/Default',
			width: 450,
			height: 160
		});
		$("#trap_frame").ligerPanel({
			title: 'Trap IP Setup',
			width: 578,
			height: 160
		});
		$("#upgrade_frame").ligerPanel({
			title: 'Upgrade',
			width: 450,
			height: 160
		});
		$('#defaultPara').on({
			click: function () {
				$("#defaultBar").hide();
				$("#prompts").show();
				CommonFrame.confirm({
					id: "common_confirm_model",
					title: "",
					message: "Are you sure default parameters?(Device will restart.)",
					operate: function (result) {
						(result == true) ? applyTypePara(GlobalSpace.DefaultFormId) : console.log("Cancle default ");
					}
				});
			}
		});

		$("#selRetSon").multiselect({
			noneSelectedText: "==Please select==",
			checkAllText: "Select all",
			uncheckAllText: 'Unselect all',
			selectedList: 0
		});
		/*$("#selSerialToSon").multiselect({
			multiple: false,
			noneSelectedText: "==Please select==",
			// checkAllText: "Select all",
			uncheckAllText: 'Unselect all',
			// selectedList: 0
		});*/
	}else{
		$("#verion_frame").ligerPanel({
			title: '版本',
			width: 450,
			height: 160
		});
		$("#reset_frame").ligerPanel({
			title: '重启',
			width: 450,
			height: 160
		});
		$("#reboot_frame").ligerPanel({
			title: '恢复出厂设置',
			width: 450,
			height: 160
		});
		$("#trap_frame").ligerPanel({
			title: 'Trap IP 设置',
			width: 578,
			height: 160
		});
		$("#upgrade_frame").ligerPanel({
			title: '升级',
			width: 450,
			height: 160
		});
		$('#defaultPara').on({
			click: function () {
				$("#defaultBar").hide();
				$("#prompts").show();
				CommonFrame.confirm({
					id: "common_confirm_model",
					title: "",
					message: "确定恢复出厂设置吗?(设备将重启.)",
					operate: function (result) {
						(result == true) ? applyTypePara(GlobalSpace.DefaultFormId) : console.log("Cancle default ");
					}
				});
			}
		});

		$("#selRetSon").multiselect({
			noneSelectedText: "==请选择==",
			checkAllText: "全选",
			uncheckAllText: '全不选',
			selectedList: 0
		});
		/*$("#selSerialToSon").multiselect({
			multiple: false,
			noneSelectedText: "==请选择==",
			// checkAllText: "全选",
			uncheckAllText: '全不选',
			// selectedList: 0
		});*/



	}
	$('#btnRetSon').on({
		click:function (){applyResetSonBoard();}
	});
	$('#btnSerialToSon').on({
		click:function (){SerToSonBoard();}
	});

	init_board_title();
	init_system();
	$("#myForm").ajaxForm(upload_ajax);
});

/*
 function setup_tsoip(){
 var json_obj = {TSOIP_NET:{}},
 jsonStr = "",
 ajax_para={},
 temp_arr = [],
 i=0;

 if(!confirm('Save TS over IP Network setting?')){
 return 0;
 }

 json_obj.TSOIP_NET = GlobalSpace.TSOIP_NET;
 jsonStr= $.toJSON(json_obj);

 ajax_para.type = DEF.SEND_TYPE.GIVE;
 ajax_para.form_id = GlobalSpace.DEF_TSOIP_NET;
 ajaxWrap(jsonStr, apply_callback, ajax_para);
 }

 function setup_tsoip_mode(){
 var G = GlobalSpace,
 json_obj = {TSOIP_MODE:{}},
 jsonStr = "",
 ajax_para={};

 if(!confirm('Change Gigabit Mode?')){
 return 0;
 }

 G.TSOIP_MODE.value[DEF.TSOIP_MODE.TSIP_MODE] = $('#tsoip_mode').val();
 json_obj.TSOIP_MODE = GlobalSpace.TSOIP_MODE;
 jsonStr= $.toJSON(json_obj);

 ajax_para.type = DEF.SEND_TYPE.GIVE;
 ajax_para.form_id = GlobalSpace.DEF_TSOIP_MODE;
 ajaxWrap(jsonStr, apply_callback, ajax_para);
 }

 */