﻿/**
* jQuery pbiui 1.0.0
* 
* Author xyf [ xyf_victor@163.com ] 
* 
*/
var CommonFrame = {
	confirm:function(params){
		var model = $("#"+params.id);
		model.find(".title").html(params.title);
		model.find(".message").html(params.message);

		//每次都将监听先关闭，防止多次监听发生，确保只有一次监听
		model.find(".cancel").off("click");
		model.find(".ok").off("click");

		model.find(".ok").on("click",function(){
			params.operate(true)
		});
		model.find(".cancel").on("click",function(){
			params.operate(false)
		})
	}
};
var pidsType =
	[
		0x00,"unused",
		0x01,"Mpeg1 Video",
		0x02,"Mpeg2 Video",
		0x03,"Mpeg1 Audio",
		0x04,"Mpeg2 Audio",
		0x05,"Private Data",
		0x06,"Private Data",
		0x07,"MHEG Data",
		0x08,"DSM CC",
		0x09,"Auxiliary  Data",
		0x0a,"DSM CC",
		0x0b,"DSM CC",
		0x0c,"DSM CC",
		0x0d,"DSM CC",
		0x0e,"Auxiliary Data",
		0x0f,"Mpeg22 AAC",
		0x10,"Mpeg4 Video",
		0x11,"Mpeg4 AAC",
		0x12,"MPEG-4 FlexMux",
		0x13,"MPEG-4 FlexMux",
		0x14,"DSM CC",
		0x15,"Meta Data",
		0x16,"Meta Data",
		0x17,"DSM CC Meta",
		0x18,"DSM CC Meta",
		0x19,"Download Meta",
		0x1a,"IPMP",
		0x1b,"H.264 Video",
		0x1c,"Reserved",
		0x1d,"Reserved",
		0x1e,"Reserved",
		0x1f,"Reserved",
		0x20,"Reserved",
		0x21,"Reserved",
		0x22,"Reserved",
		0x23,"Reserved",
		0x24,"H.265 Video",
		0x25,"Reserved",
		0x26,"Reserved",
		0x27,"Reserved",
		0x28,"Reserved",
		0x29,"Reserved",
		0x2a,"Reserved",
		0x2b,"Reserved",
		0x2c,"Reserved",
		0x2d,"Reserved",
		0x2e,"Reserved",
		0x2f,"Reserved",
		0x30,"Reserved",
		0x31,"Reserved",
		0x32,"Reserved",
		0x33,"Reserved",
		0x34,"Reserved",
		0x35,"Reserved",
		0x36,"Reserved",
		0x37,"Reserved",
		0x38,"Reserved",
		0x39,"Reserved",
		0x3a,"Reserved",
		0x3b,"Reserved",
		0x3c,"Reserved",
		0x3d,"Reserved",
		0x3e,"Reserved",
		0x3f,"Reserved",
		0x40,"Reserved",
		0x41,"Reserved",
		0x42,"AVS+",
		0x43,"AVS+",
		0x44,"Reserved",
		0x45,"Reserved",
		0x46,"Reserved",
		0x47,"Reserved",
		0x48,"Reserved",
		0x49,"Reserved",
		0x4a,"Reserved",
		0x4b,"Reserved",
		0x4c,"Reserved",
		0x4d,"Reserved",
		0x4e,"Reserved",
		0x4f,"Reserved",
		0x50,"Reserved",
		0x51,"Reserved",
		0x52,"Reserved",
		0x53,"Reserved",
		0x54,"Reserved",
		0x55,"Reserved",
		0x56,"Reserved",
		0x57,"Reserved",
		0x58,"Reserved",
		0x59,"Reserved",
		0x5a,"Reserved",
		0x5b,"Reserved",
		0x5c,"Reserved",
		0x5d,"Reserved",
		0x5e,"Reserved",
		0x5f,"Reserved",
		0x60,"Reserved",
		0x61,"Reserved",
		0x62,"Reserved",
		0x63,"Reserved",
		0x64,"Reserved",
		0x65,"Reserved",
		0x66,"Reserved",
		0x67,"Reserved",
		0x68,"Reserved",
		0x69,"Reserved",
		0x6a,"Reserved",
		0x6b,"Reserved",
		0x6c,"Reserved",
		0x6d,"Reserved",
		0x6e,"Reserved",
		0x6f,"Reserved",
		0x70,"Reserved",
		0x71,"Reserved",
		0x72,"Reserved",
		0x73,"Reserved",
		0x74,"Reserved",
		0x75,"Reserved",
		0x76,"Reserved",
		0x77,"Reserved",
		0x78,"Reserved",
		0x79,"Reserved",
		0x7a,"Reserved",
		0x7b,"Reserved",
		0x7c,"Reserved",
		0x7d,"Reserved",
		0x7e,"Reserved",
		0x7f,"Reserved",
		0x80,"DigiCipher II",
		0x81,"Dolby Audio",
		0x82,"DTS 6CH Audio",
		0x83,"Dolby TrueHD",
		0x84,"Dolby D+",
		0x85,"DTS 8CH Audio",
		0x86,"DTS 8CH Audio",
		0x87,"Dolby D+",
		0x88,"Private Data",
		0x89,"Private Data",
		0x8a,"Private Data",
		0x8b,"Private Data",
		0x8c,"Private Data",
		0x8d,"Private Data",
		0x8e,"Private Data",
		0x8f,"Private Data",
		0x90,"subtitle",
		0x91,"Private Data",
		0x92,"Private Data",
		0x93,"Private Data",
		0x94,"Private Data",
		0x95,"ATSC DSM CC",
		0x96,"Private Data",
		0x97,"Private Data",
		0x98,"Private Data",
		0x99,"Private Data",
		0x9a,"Private Data",
		0x9b,"Private Data",
		0x9c,"Private Data",
		0x9d,"Private Data",
		0x9e,"Private Data",
		0x9f,"Private Data",
		0xa0,"Private Data",
		0xa1,"Private Data",
		0xa2,"Private Data",
		0xa3,"Private Data",
		0xa4,"Private Data",
		0xa5,"Private Data",
		0xa6,"Private Data",
		0xa7,"Private Data",
		0xa8,"Private Data",
		0xa9,"Private Data",
		0xaa,"Private Data",
		0xab,"Private Data",
		0xac,"Private Data",
		0xad,"Private Data",
		0xae,"Private Data",
		0xaf,"Private Data",
		0xb0,"Private Data",
		0xb1,"Private Data",
		0xb2,"Private Data",
		0xb3,"Private Data",
		0xb4,"Private Data",
		0xb5,"Private Data",
		0xb6,"Private Data",
		0xb7,"Private Data",
		0xb8,"Private Data",
		0xb9,"Private Data",
		0xba,"Private Data",
		0xbb,"Private Data",
		0xbc,"Private Data",
		0xbd,"Private Data",
		0xbe,"Private Data",
		0xbf,"Private Data",
		0xc0,"DigiCipher II",
		0xc1,"Dolby D SC",
		0xc2,"ATSC DSM CC",
		0xc3,"Private Data",
		0xc4,"Private Data",
		0xc5,"Private Data",
		0xc6,"Private Data",
		0xc7,"Private Data",
		0xc8,"Private Data",
		0xc9,"Private Data",
		0xca,"Private Data",
		0xcb,"Private Data",
		0xcc,"Private Data",
		0xcd,"Private Data",
		0xce,"Private Data",
		0xcf,"AAC SC",
		0xd0,"Private Data",
		0xd1,"Ultra HD video",
		0xd2,"Private Data",
		0xd3,"Private Data",
		0xd4,"Private Data",
		0xd5,"Private Data",
		0xd6,"Private Data",
		0xd7,"Private Data",
		0xd8,"Private Data",
		0xd9,"Private Data",
		0xda,"Private Data",
		0xdb,"H.264 SC",
		0xdc,"Private Data",
		0xdd,"Private Data",
		0xde,"Private Data",
		0xdf,"Private Data",
		0xe0,"Private Data",
		0xe1,"Private Data",
		0xe2,"Private Data",
		0xe3,"Private Data",
		0xe4,"Private Data",
		0xe5,"Private Data",
		0xe6,"Private Data",
		0xe7,"Private Data",
		0xe8,"Private Data",
		0xe9,"Private Data",
		0xea,"WMV",
		0xeb,"Private Data",
		0xec,"Private Data",
		0xed,"Private Data",
		0xee,"Private Data",
		0xef,"Private Data",
		0xf0,"Private Data",
		0xf1,"Private Data",
		0xf2,"Private Data",
		0xf3,"Private Data",
		0xf4,"Private Data",
		0xf5,"Private Data",
		0xf6,"Private Data",
		0xf7,"Private Data",
		0xf8,"Private Data",
		0xf9,"Private Data",
		0xfa,"PCR",
		0xfb,"PMT",
		0xfc,"Ghost Data",
		0xfd,"EMM Data",
		0xfe,"ECM Data",
		0xff,"Private Data"
	];
/*-End--2016/02/18-----*/

(function ($){
	$.DEF={
		CHARSET:{
			UTF_8:0,
			GB2312:1,
			BIG_5:2,
			ISO_10646_1_BIG5:3,
			ISO_8859_1:4,
			ISO_8859_2:5,
			ISO_8859_3:6,
			ISO_8859_4:7,
			ISO_8859_5:8,
			ISO_8859_6:9,
			ISO_8859_7:10,
			ISO_8859_8:11,
			ISO_8859_9:12,
			ISO_8859_10:13,
			ISO_8859_11:14,
			ISO_8859_12:15,
			ISO_8859_13:16,
			ISO_8859_14:17,
			ISO_8859_15:18,
			ISO_8859_16:19,
			
			LEN:20
		},
		DEV_TYPE:{
			MODULATOR:(1<<0),
			MUX:(1<<1), //2
			CA:(1<<2) //4
		},
		//通讯类型
		INTERACT_TYPE:{
			AJAX:0
		},
		AJAX_BK:{
			DEFAULT:0,
			LOAD:1,
			
			REMOVE2:255
		},
		STREAM_TYPE:{
			VIDEO_S:0x02,
			AUDIO_S:0x04,
			OTHER_S:0x06,
			ECM_S:0x01,
			EMM_S:0x03,
			PMT_S:0x07,
			MUX_M:0x0a,
			CAS_M:0x0b
		},
		PROGRAM_TYPE:{
			TV:1,
			BROADCAST:2,
			DATA:3
		},
		WEB_SETTING:{
			INPUT_P_SHOW:0,
			INPUT_PORT:1,
			VERSION:2,
			CHAR_INSTR:3,
			CHAR_OUTSTR:4,
			
			LEN:5
		},
		INIT:{
			DEV_NAME:0,
			DEV_SN:1,
			
			TSIP_PORT:2,
			ASIIN_CH:3,
			ASIOUT_CH:4,
			IPIN_CH:5,
			TOTAL_TSIN:6,
			MUX_CH:7,
			UPGRADE_FLAG:8,
			
			WEB_USE:9,
			
			DEVICE_TYPE:10,
			LEN:11
		},
		INPUT_TREE:{
		//dim1
			INDEX:0,
			LOCK:1,
			PAT_CRC:2,
			PROS_NUM:3,
			EMMPIDS_NUM:4,
			IPS_NUM:5,
			
			LEN:6,
	
			//dim2 IP_PARAS
	
			//dim3 PROGRAM_PARAS
			PROS:{
				NAME:0,
				PROVIDER_NAME:1,
				PN:2,
				PMT:3,
				PCR:4,
				FCA_MODE:5,
				SER_TYPE:6,
				ESPIDS_NUM:7,
				ECMPIDS_NUM:8,
				
				LEN:9,
				
			//dim4 ES_PIDS	
				ESPIDS:{
					 PID:0,
					 TYPE:1,
					
					 LEN:2
				}
			}
		},
		MUX_TREE:{
			//dim1
			INDEX:0,
			SET_NUM:1,
			PROS_NUM:2,
			PID_PASS_NUM:3,
			NIT_NUM:4,
	
			LEN:5,
			
			//dim2 programs
			PROS:{
				SOR_INDEX:0,
				OLD_INFOS_NUM:1,
				MUX_INFOS_NUM:2,
				MUX_PIDS_NUM:3,
				CAS_NUM:4,
				
				LEN:5,
				OLD_INFOS:{
			//dim3 old infos
					PN:0,
					PMT:1,
					PCR:2,
					PRO_INDEX:3,
					// S_TYPE:3,
					// PRO_NAME:4,
					// PROVIDER_NAME:5,
					
					LEN:4
				},
				MUX_INFOS:{
			//dim3 mux infos
					PN:0,
					PMT:1,
					PCR:2,
					S_TYPE:3,
					PRO_NAME:4,
					PROVIDER_NAME:5,
					
					LEN:6
				},
				MUX_PIDS:{
			//dim4 mux pid	
					ORI:0,
					TYPE:1,
					MUX:2,
					CA_ENA:3,
					
					LEN:4
				},
				CAS:{
					TYPE:0,
					ITEM_NUM:1,
					LEN:2,
					
					//CAS_TYPE&INDEX
					ITEM:{
						CLEAR:0,
						BISS1:1,
						BISSE:2,
						SIM:3,
						LEN:4,
						//BISS-1
						ITEM_BISS_1:{
							ENC_SES: 0,
							LEN:1
						},
						//BISS-E
						ITEM_BISS_E:{
							ENC_SES:0,
							INJ_ID:1,
			
							LEN:2
						},	
						//Simlcrypt
						ITEM_SIM:{
							ENA:0,
							AC_INDEXA:1,
							ECM_PID:2,
							
							LEN:3
						}
					}
				}
			},
			//dim2 set
			SET:{
				ENA:0,
				BITRATE:1,
				AUTO:2,
				SDT:3,
				NIT:4,
				EIT:5,
				TSID:6,
				OID:7,
				IPOUT_NUM:8,
				
				LEN:9,
				IPOUT:{
				//dim3 ipout set	
					PORT_ENA:0,
					UDP_O_RTP:1,
					IPS_NUM:2,
					
					LEN:3
				}
			},
			
			//dim2 pid pass
			PID_PASS:{
				CH:0,
				ORI:1,
				MUX:2,
	
				LEN:3
			}
			//dim2 nit
		}
	};
	//动态删除select中的所有options：
	$.clearAllOptions = function (objSelect) {
		if(objSelect.options.length > 0)
			objSelect.options.length=0;
	};

	/*异步 没有 页面load 效果的 Ajax*/
	$.sdAjaxWrap = function (ajaxParam, fnSucess, fnError) {
		$.ajax({
			dataType: (typeof ajaxParam.dataType === undefined)?"json":ajaxParam.dataType,
			type: (typeof ajaxParam.type === undefined)?"POST":ajaxParam.type,
			url:(typeof ajaxParam.url === undefined)?"":ajaxParam.url,
			async:(typeof ajaxParam.async === undefined)?true:ajaxParam.async,
			timeout:(typeof ajaxParam.timeout === undefined)?20000:ajaxParam.timeout,
			data:(typeof ajaxParam.data === undefined)?"":ajaxParam.data,
			cache:(typeof ajaxParam.cache === undefined)?true:ajaxParam.cache,
			beforeSend:function(XMLHttpRequest){
				//可修改 XMLHttpRequest 对象的函数，如添加自定义 HTTP 头
			},
			success:function(data){
				fnSucess(data);
			},
			dataFilter : function(data, type){
				if(data == "timeOut" || data == "[object XMLDocument]"){
					console.log("ajax请求，发现session过期，重新刷新页面，跳转到登录页面");
					window.location.reload();
				}else{
					return data; //必须return
				}
			},
			error:function(xhr,errMsg,catchObj){
				console.log("Ajax errMsg:"+errMsg);
				console.log("Ajax catchObj:"+catchObj);
				fnError();
/*				if(errMsg == "timeout"){
				}else if(errMsg == "error"){

				}else if(errMsg == "notmodified"){

				}else if(errMsg == "parsererror"){

				}else{
					//Null
				}*/
			}
		});
	};

	/*
	 *数据传输
	 */
	$.pbi_test=function(){console.log('pbi_test!!');};
	$.pbi_ajaxWrap=function(jsonStr, ajax_p, fn_s, fn_f){
		var ajax_para={
			url:"",
			bk_type:$.DEF.AJAX_BK.DEFAULT,
			
			bk_fn:undefined,
			bkrm_fn:undefined,
			bkrm_dis:0, //禁用蒙板移除
			bkrm_type:$.DEF.AJAX_BK.DEFAULT,
			bkrm_front:0//在获取数据前移除，在获取数据后移�?
		};
			
		jQuery.extend(ajax_para,ajax_p);	

//	alert($.toJSON(ajax_para));
		$.ajax({
			dataType: "json",
			type: 'POST',
			url:ajax_para.url,
			timeout:20000,
			data:{json:jsonStr},
			beforeSend:function(XMLHttpRequest){
				if(ajax_para.bk_fn){
					ajax_para.bk_fn(ajax_para.bk_type);	
				}
			},
			success: function(data){
				if(!ajax_para.bkrm_dis && ajax_para.front && ajax_para.bkrm_fn){
					ajax_para.bkrm_fn(DEF.AJAX_BK.REMOVE2);
				}
				
				if(fn_s){


					ajax_para.success=1;
					fn_s(data, ajax_para);			
				}
					
				if(!ajax_para.bkrm_dis && !ajax_para.front && ajax_para.bkrm_fn){
					ajax_para.bkrm_fn(ajax_para.bk_type);
				}
			},
			error: function(xhr,err){
				if(err == "timeout")
						return;
				if(!ajax_para.bkrm_dis && ajax_para.front && ajax_para.bkrm_fn){
					ajax_para.bkrm_fn(DEF.AJAX_BK.REMOVE2);
				}
				
				if(fn_f){
					ajax_para.success=0;
					fn_f(err, ajax_para);
				}
				
				if(!ajax_para.bkrm_dis && !ajax_para.front && ajax_para.bkrm_fn){
					ajax_para.bkrm_fn(ajax_para.bk_type);
				}
			}
		});	
	};
	$.pbi_ajaxWrap_mainmux=function(jsonStr, ajax_p, fn_s, fn_f){
		var ajax_para={
			url:"",
			bk_type:$.DEF.AJAX_BK.DEFAULT,
			
			bk_fn:undefined,
			bkrm_fn:undefined,
			bkrm_dis:0, //禁用蒙板移除
			bkrm_type:$.DEF.AJAX_BK.DEFAULT,
			bkrm_front:0//在获取数据前移除，在获取数据后移�?
		};
			
		jQuery.extend(ajax_para,ajax_p);	

	console.log($.toJSON(ajax_para));
		$.ajax({
			dataType: "json",
			type: 'POST',
			url:ajax_para.url,
			async:true,
			data:{json:jsonStr},
			beforeSend:function(XMLHttpRequest){
				if(ajax_para.bk_fn){
					ajax_para.bk_fn(ajax_para.bk_type);	
				}
			},
			success: function(data){

				if(!ajax_para.bkrm_dis && ajax_para.front && ajax_para.bkrm_fn){
					ajax_para.bkrm_fn(DEF.AJAX_BK.REMOVE2);
				}
				
				if(fn_s){
					ajax_para.success=1;
					fn_s(data, ajax_para);			
				}
					
				if(!ajax_para.bkrm_dis && !ajax_para.front && ajax_para.bkrm_fn){
					ajax_para.bkrm_fn(ajax_para.bk_type);
				}
			},
			error: function(data){
				if(!ajax_para.bkrm_dis && ajax_para.front && ajax_para.bkrm_fn){
					ajax_para.bkrm_fn(DEF.AJAX_BK.REMOVE2);
				}
				
				if(fn_f){
					ajax_para.success=0;
					fn_f(data, ajax_para);
				}
				
				if(!ajax_para.bkrm_dis && !ajax_para.front && ajax_para.bkrm_fn){
					ajax_para.bkrm_fn(ajax_para.bk_type);
				}
			}
		});	
	};
	//取文�?
	$.pbi_GetFile=function(str){
		window.location.href = str;
	};
	/*
	 *判断字符串所占的字节�?
	 */
	$.pbi_GetCharLength=function (str)
	{
	    var iLength = 0;  //记录字符的字节数
	    for(var i = 0;i<str.length;i++)//遍历字符串中的每个字�?
	    {
	    	
	        if(str.charCodeAt(i)>255)   //如果当前字符的编码大�?55
	        {
	            iLength += 2;    //所占字节数�?
	        }
	        else{
	            iLength += 1;   //否则所占字节数�?
	        }
	    }
	    return iLength;   //返回字符所占字节数
	};
	/* 
	 * 检测对象是否是空对??不包含任何可读属????
	 * 方法既检测对象本身的属性，也检测从原型继承的属??因此没有使hasOwnProperty)??
	 */
	$.pbi_isEmptyObject = function(o){
	    for(var n in o){
	        return false;
	    }
	    return true;
	};
	/* 
	 * 检测对象是否是空对??不包含任何可读属????//如你上面的那个对象就是不含任何可读属??
	 * 方法只既检测对象本身的属性，不检测从原型继承的属�??
	 */
	$.pbi_isOwnEmpty = function(o){
	    for(var n in o){
			if(o.hasOwnProperty(n))
	        return false;
	    }
	    return true;
	};

	//pbi_Validform INIT
	$.pbi_ValidformInit=function(){
		$.extend($.Tipmsg,{
			tit:"title",
			w:"Please enter the correct information!",
			def:"Please enter the correct information!",
			undef:"datatype undefine!",
			reck:"",
			r:"Information verification is pass!",
			c:"Test the information...",
			s:"Please enter the information!",
			v:"The information is not validated!",
			p:"Are submitting data, please wait...",
			err:"Error info, please try again!",
			null:"Please fill in the data!",
			src_ip_0_errormsg:"The rang is between 1 and 223!",
			src_ip_1_2_3_errormsg:"The rang is between 0 and 255"
		});
	
		//参数gets是获取到的表单元素值，obj为当前表单元素，curform为当前验证的表单，regxp为内置的一些正则表达式的引??
		$.extend($.Datatype,{
			'z2-4':/^[\u4E00-\u9FA5\uf900-\ufa2d]{2,4}$/,
			'mux_bitrate':/^100000$|^0\d{0,5}$|^\d{1,5}$/,
			'ip':/^2[0-4]\d$|^25[0-5]$|^[01]?\d\d?$/,
			'unicast_0':function(gets,obj,curform){
				if((parseInt(gets))>=1 && (parseInt(gets)<=223) && (!isNaN(gets)) && (parseInt(gets)) != 127){return true;}
					return false;
			},
			'auto_unicast_0':function(gets,obj,curform){
				if((parseInt(gets))>=0 && (parseInt(gets)<=223) && (!isNaN(gets)) && (parseInt(gets)) != 127){return true;}
					return false;
			},
			'unicast_1_2_3':function(gets,obj,curform){
				if((parseInt(gets))>=0 && (parseInt(gets)<=255) && (!isNaN(gets))){return true;}
					return false;
			},
			'Threshold':function(gets,obj,curform){
				if((parseInt(gets))>=0 && (parseInt(gets)<=216000) && (!isNaN(gets))){return true;}
					return false;				
			},
			'BYTE2':function(gets,obj,curform){
				if(parseInt(gets)<=65535){return true;}
					return false;
			},
			'muxname':function(gets,obj,curform){
				if($.pbi_GetCharLength(gets)<=12&&$.pbi_GetCharLength(gets)>=0){return true;}
					return false;
			},
			'name':function(gets,obj,curform){
				if($.pbi_GetCharLength(gets)<=27&&$.pbi_GetCharLength(gets)>0){return true;}
					return false;
			},
			'es_rpid':function(gets,obj,curform){
				if(parseInt(gets)<=8191&&parseInt(gets)>31){return true;}
					return false;
			},
			'pid_d':function(gets,obj,curform){
				if(parseInt(gets)<8191&&parseInt(gets)>31){return true;}
					return false;
			},
			'pid_x':function(gets,obj,curform){
				if(parseInt(gets,16)<8191&&parseInt(gets,16)>31){return true;}
					return false;
			},
			'sdt':function(gets,obj,curform){
				if(parseInt(gets)<=2000&&parseInt(gets)>=25){return true;}
				return false;
			},
			'pat':function(gets,obj,curform){
				if(parseInt(gets)<=500&&parseInt(gets)>=25){return true;}
				return false;
			}
		});
	
	};
	
	$.pbi_VFtiptypefn=function(msg,o,cssctl){
		var objtip=$('#'+o.obj.attr("id")+'_t');
		cssctl(objtip,o.type);
		objtip.text(msg);
		
		if(o.type==2){
			objtip.hide();
		}else{
			objtip.show();
		}
	};
/*
 *pbi_Validform function end 
 ******************/
/*************************************************
 *fn function
 *************************************************/

	$.fn.extend({
		'pbi':function(){
			var para_len=0,
				option={};
				para_len = arguments.length;
				
			if(para_len){
				option = arguments[0];
			
				this.val();
				/*
				return this.each(function(){
					alert(2);
				});*/
			}			
		}
		
		/*
		 *表单验证
		 */
		
		
		/*
		 *树生�?
		 */
		
		/*
		 *表格生成
		 */
		
		/*
		 * 翻页
		 */
		
		/*
		 *select
		 */
		
		/*
		 *文件另存�?
		 */
		
		
	}); 
//标题栏手风琴效果
	$.fn.pbi_accordion=function(){
		return this.each(function(){
			$(this).on({
				click:function () {
					var dom_divs=$(this).siblings();
					
					dom_divs.each(function(){
						if($(this).is(':hidden'))
							$(this).show();
						else
							$(this).hide();
					});
				}
			});
		});
	};	
//dis 根据标签对页面显示做二次判断
	$.fn.pbi_dis=function(millisec){
		return this.each(function(millisec){
			var dis = parseInt($(this).attr('dis'));
			
			if(dis){
				$(this).show(millisec);
			}else{		
				$(this).hide();
			}
		});
	};	
//控制标签的移�?
	$.fn.pbi_move=function(jq_dom,x,y){
		return this.each(function(jq_dom,x,y){
			$(this).click;
		});
	};
//添加点击标示
	$.fn.bindCheckBoxFn = function (){
		var len = arguments.length,
			para = arguments;
			
		return this.each(function(len,para){
			var dom = $(this).find('b').length?$(this).find('b'):$(this),
				parent = len?para[0]:0;
			
			//bind all check function	
			if(parent){
				parent.toggle(
			  		function () {$(this).find('b').addClass('ch');},
			  		function () {$(this).find('b').removeClass('ch');}
				).hover(
					function () {$(this).addClass("on");},
			  		function () {$(this).removeClass("on");
				});
			}else{
				//bind check function
				dom.on({
					click:function () {if($(this).hasClass("ch")){$(this).removeClass('ch');}
										else{$(this).addClass('ch');}}
				}).hover(
					function () {$(this).addClass("on");},
			  		function () {$(this).removeClass("on");
				});
			}	
		});
	};

	$.fn.unbindCheckBoxFn = function (){
		var len = arguments.length,
			para = arguments;
			
		return this.each(function(len,para){
			if(len){
				$(this).off();
			}else{
				var dom = $(this).find('b').length?$(this).find('b'):$(this);
				dom.off();
			}
		});
	};

//生成表格
/*
 * row.thead
 * row.node
 * row.id
 * row.class_
 * ***********
 * node.con
 * node.type
 * node.id
 * node.class_
 * ***********
 */
$.extend($.DEF,
	{
		THEAD_TYPE:{
			HEAD:1
		},
		TC_TYPE:{
			FONT:0
		},
		TCELL_STYLE:{
			NORMAL:0,
			B:1,
			I:2,
			GREEN:4,
			RED:8,
			YELLOW:12
		}
	});
	$.fn.pbi_genTable=function(array){
		return this.each(function(){
			var str='',
				id_str='',
				class_str='',
				con_str='',
				arr_len=array.length,
				i=0,
				j=0,
				tbody_tag=1,
				tableV=[],
				val=[],
				row={},
				node=[];
			
			for(i;i<arr_len;i++){
				row = array[i];
				node = row.node;
				if((row.thead)&&(i==0)){
					str += '<thead><tr>';
						for(j=0; j<node.length; j++){
							str+='<th>'+(node[j].con?node[j].con:'')+'</th>';
						}
					str += '</tr></thead>';
//					alert(str);
					continue;
				}
				if(tbody_tag){
					str += '<tbody>';
					tbody_tag=0;
				}
				id_str = (row.id?(' id="'+row.id+'"'):'');
				class_str = (row.class_)?' class="'+row.class_+'"':'';
				str += '<tr'+id_str+class_str+'>';
				
				for(j=0; j<node.length;j++){
					id_str = (node[j].id?(' id="'+node[j].id+'"'):'');
					class_str = (node[j].class_?' class="'+node[j].class_+'"':'');
					str += '<td'+id_str+class_str+'>';
					
					con_str = node[j].con;
					
					if(node[j].type & $.DEF.TCELL_STYLE.B){
						con_str = '<b>'+con_str+'</b>';
					}

					if(node[j].type & $.DEF.TCELL_STYLE.I){
						con_str = '<i>'+con_str+'</i>';
					}
					
					if((node[j].type & $.DEF.TCELL_STYLE.YELLOW) == $.DEF.TCELL_STYLE.GREEN){
						con_str = '<span class="g">'+con_str+'</span>';
					}
					
					if((node[j].type & $.DEF.TCELL_STYLE.YELLOW) == $.DEF.TCELL_STYLE.RED){
						con_str = '<span class="r">'+con_str+'</span>';
					}
					
					str += con_str;				
					str += '</td>';
				}
				
				str += '</tr>';
				
				if(!tbody_tag&&i==arr_len-1){
					str += '</tbody>';
				}
			}
			
			$(this).html(str);
		});
	};	
/*
 * node.con
 * node.type
 * node.tag
 * ***********
 * TCELL_STYLE:{
			NORMAL:0,
			B:1,
			I:2,
			GREEN:4,
			RED:8,
			YELLOW:12,
		}
 */
	$.fn.pbi_setValue=function(node){
		return this.each(function(){
			var i = 0,
				con_str = '';
			
			for(i; i<node.length; i++){
				if($(this).find(node[i].tag).length){
					con_str = node[i].con;
					
					if(node[i].type & $.DEF.TCELL_STYLE.B){
						con_str = '<b>'+con_str+'</b>';
					}

					if(node[i].type & $.DEF.TCELL_STYLE.I){
						con_str = '<i>'+con_str+'</i>';
					}
					
					if((node[i].type & $.DEF.TCELL_STYLE.YELLOW) == $.DEF.TCELL_STYLE.GREEN){
						con_str = '<span class="g">'+con_str+'</span>';
					}
					
					if((node[i].type & $.DEF.TCELL_STYLE.YELLOW) == $.DEF.TCELL_STYLE.RED){
						con_str = '<span class="r">'+con_str+'</span>';
					}
					
					$(node[i].tag).html(con_str);
				}					
			}
		});
	};

	$.fn.pbi_genSelect = function(array,id,value){
		return this.each(function(){
			var str = '',
				tag = 0,
				arr_len=array.length,
				i=0,
				j=0;
			
			str = '<select id="'+id+'">';
			for(i;i<arr_len;i++){
				str += '<option value="'+array[i][0]+'" '+(array[i][0]==value?'selected=""':'')+'>'+array[i][1]+'</option>';
			}
			str += '</select>';
			
			$(this).html(str);
		});
	};	
})( jQuery); 

































